#/usr/bin/env python
# -*- coding: utf-8 -*-

#KrazyBrainWord 0.2
#by Lionel Roubeyrie aka joshuafr
#Copyright Lionel Roubeyrie - 2005

#***************************************************************************
 #*   This program is free software; you can redistribute it and/or modify  *
 #*   it under the terms of the GNU General Public License as published by  *
 #*   the Free Software Foundation; either version 2 of the License, or     *
 #*   (at your option) any later version.                                   *
 #*                                                                         *
 #*   This program is distributed in the hope that it will be useful,       *
 #*   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 #*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 #*   GNU General Public License for more details.                          *
 #*                                                                         *
 #*   You should have received a copy of the GNU General Public License     *
 #*   along with this program; if not, write to the                         *
 #*   Free Software Foundation, Inc.,                                       *
 #*   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 #***************************************************************************
 

from qt import *
from kbw import FormKBW
import sys, string

def transform( word ):
    '''Change normal word '''
    punc = { }
    if len( word ) > 3:
        word = list( word )
        #Searches string punctuations, places them in punc and removes it from word
        lword = range( len( word ) )
        lword.reverse() #Make the deletion in reverse order
        for i in lword:
            letter = word[ i ]
            if letter in string.punctuation:
                punc[ i ] = letter
                word.pop( i )
        #Now we reverse the ordre of the letters in the middle of the word
        f = word[ 0 ] # First letter
        m = word[ 1:-1 ] # Middle
        l = word[ -1 ] # Last
        
        #Rotate by group of 2 or 3 letters
        tmp = [ ]
        for i in range( 0, len( m ), 3 ):
            if len( m[ i: ] ) >= 3:
                mm = m[i:i+3]
            else:
                mm = m[i:]
            mm.reverse()
            [ tmp.append( letter ) for letter in mm ]
        m = tmp        
            
        #Readjust the word
        word = list( f ) + m + list( l )
        # And we replace punctuations
        if punc.__len__() > 0:
            pos = punc.keys()
            pos.sort()
            for i in pos:
                word.insert( i, punc[ i ] )
        #Word is a string, not a list
        word = string.join( word, "" )
    return word

class FormKBW_Impl(FormKBW):

    def __init__(self,parent = None,name = None,fl = 0):
        FormKBW.__init__(self,parent,name,fl)

    def kButtonOK_clicked(self):
        lines = unicode( self.kTextEditUp.text() )
        lines = lines.split('\n')
        textlines = []
        if len ( lines ) > 0:
            for line in lines:
                words = line.split()
                if len( words ) > 0:
                    textline = [ ]
                    [ textline.append( transform( word ) ) for word in words ]
                    textlines.append( string.join( textline, " ") )
                    self.kTextEditDown.setText( string.join( textlines, "\n" ) )

if __name__ == "__main__":
    a = QApplication(sys.argv)
    QObject.connect(a,SIGNAL("lastWindowClosed()"),a,SLOT("quit()"))
    w = FormKBW_Impl()
    a.setMainWidget(w)
    w.show()
    a.exec_loop()
